#include <string.h>
#include <csignal>
#include <cstdio>
#include <cstdlib>
#include <utility>
#include <set>
#include <vector>
#include "Anna.h"
#include "Bruno.h"

namespace {
	FILE *in, *out;
	int N, X, Y;
	int NumCall = 0;
	std::vector<std::vector<int>> Banmen;
}  // namespace

void wrong(int num) {
	fprintf(out, "%d\n", num);
	fflush(out);
	exit(0);  // do not exit(1)! (it might cause RE where WA is appropriate)
}

void Paint(int a, int b, int c) {
	if (a < 0 || a > 7 || a == X) wrong(1);
	if (b < 0 || b > 7 || b == Y) wrong(1);
	if (c < 0 || c > 1) wrong(2);
	if (Banmen[a][b] != 2) wrong(3);
	Banmen[a][b] = c;
	NumCall += 1;
}

int main(int argc, char** argv) {
	if (argc < 4) {
		fprintf(stderr, "Usage: %s <in> <out> <shard>\n", argv[0]);
		return 1;
	}
	
	// Open Pipe
	signal(SIGPIPE, SIG_IGN);
	out = fopen(argv[2], "w");
	in = fopen(argv[1], "r");
	int shard = atoi(argv[3]);
	
	// Prepare
	char prepare[20]; int Queries = 0;
	if (fscanf(in, "%s", prepare) != 1) {
		fprintf(stderr, "program failed to read data from manager\n");
		exit(1);
	}
	if (fscanf(in, "%d", &Queries) != 1) {
		fprintf(stderr, "program failed to read data from manager\n");
		exit(1);
	}
	fprintf(out, "Start\n"); fflush(out);
	
	if (shard == 0) {
		for (int challenge = 1; challenge <= Queries; challenge++) {
			Banmen = std::vector<std::vector<int>>(8, std::vector<int>(8, 2));
			NumCall = 0;
			
			// Anna Start
			char flag[20];
			if (fscanf(in, "%s", flag) != 1) {
				fprintf(stderr, "Anna failed to read data from manager");
				wrong(-1);
			}
			if (!strcmp("WA", flag)) exit(0);
			else if (strcmp("Success", flag)) wrong(-1);
			
			// Input Values
			char buf[109];
			if (fscanf(in, "%d%d%d", &X, &Y, &N) != 3) {
				fprintf(stderr, "Anna failed to read data from manager");
				wrong(-1);
			}
			if (fscanf(in, "%s", buf) != 1) {
				fprintf(stderr, "Anna failed to read data from manager");
				wrong(-1);
			}
			std::string S;
			for (int i = 0; i < N; i++) S += buf[i];
			
			// Call Anna
			Anna(X, Y, N, S);
			if (NumCall != 49) wrong(4);
			fprintf(out, "%d\n", 0); fflush(out);
			for (int i = 0; i < 8; i++) {
				for (int j = 0; j < 8; j++) {
					if (j >= 1) fprintf(out, " ");
					fprintf(out, "%d", Banmen[i][j]);
				}
				fprintf(out, "\n"); fflush(out);
			}
		}
	}
	
	if (shard == 1) {
		for (int challenge = 1; challenge <= Queries; challenge++) {
			// Bruno Start
			char flag[20];
			if (fscanf(in, "%s", flag) != 1) {
				fprintf(stderr, "Bruno failed to read data from manager");
				wrong(-1);
			}
			if (!strcmp("WA", flag)) exit(0);
			else if (strcmp("Success", flag)) wrong(-1);
			
			// Input Values
			std::vector<std::vector<int>> T(8, std::vector<int>(8, 0));
			if (fscanf(in, "%d", &N) != 1) {
				fprintf(stderr, "Bruno failed to read data from manager");
				wrong(-1);
			}
			for (int i = 0; i < 8; i++) {
				for (int j = 0; j < 8; j++) {
					if (fscanf(in, "%d", &T[i][j]) != 1) {
						fprintf(stderr, "Bruno failed to read data from manager");
						wrong(-1);
					}
				}
			}
			
			// Call Bruno
			std::string String = Bruno(N, T);
			if ((int)String.size() > 43) wrong(5);
			for (int i = 0; i < (int)String.size(); i++) {
				if (String[i] != 'A' && String[i] != 'B') wrong(6);
			}
			String = "X" + String;
			fprintf(out, "%d\n", 0); fflush(out);
			fprintf(out, "%d\n", (int)String.size()); fflush(out);
			for (int i = 0; i < (int)String.size(); i++) {
				fprintf(out, "%c", String[i]);
			}
			fprintf(out, "\n"); fflush(out);
		}
	}
	return 0;
}
